=== modified file 'NEWS'
--- NEWS	2008-05-07 05:09:19 +0000
+++ NEWS	2008-05-07 10:04:52 +0000
@@ -24,6 +24,9 @@
     * Diff now handles revision specs like "branch:" and "submit:" more
       efficiently.  (Aaron Bentley)
 
+    * More friendly error given when attempt to start the smart server
+      on an address already in use. (Andrea Corbellini, #200575)
+
     * Pull completes much faster when there is nothing to pull.
       (Aaron Bentley)
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-05-02 07:31:24 +0000
+++ bzrlib/errors.py	2008-05-07 10:04:52 +0000
@@ -2667,3 +2667,12 @@
         self.path = path
         self.kind = kind
         self.user_encoding = osutils.get_user_encoding()
+
+
+class CannotBindAddress(BzrError):
+
+    _fmt = 'Cannot bind address "%(host)s:%(port)i": %(orig_error)s.'
+
+    def __init__(self, host, port, orig_error):
+        BzrError.__init__(self, host=host, port=port,
+            orig_error=orig_error[1])

=== modified file 'bzrlib/smart/server.py'
--- bzrlib/smart/server.py	2008-04-29 13:43:40 +0000
+++ bzrlib/smart/server.py	2008-05-07 06:19:52 +0000
@@ -64,7 +64,10 @@
         if sys.platform != 'win32':
             self._server_socket.setsockopt(socket.SOL_SOCKET,
                 socket.SO_REUSEADDR, 1)
-        self._server_socket.bind((host, port))
+        try:
+            self._server_socket.bind((host, port))
+        except self._socket_error, message:
+            raise errors.CannotBindAddress(host, port, message)
         self._sockname = self._server_socket.getsockname()
         self.port = self._sockname[1]
         self._server_socket.listen(1)

